var dbname = ".\\data\\db.fdb";
var scriptFolder = ".\\data\\sql\\db\\";

var quote = String.fromCharCode(34);
var dbname_bak = "";
var fso = WScript.CreateObject("Scripting.FileSystemObject");

try {
	var nargs = WScript.Arguments.Named;
	var uargs = WScript.Arguments.Unnamed;
	var i = 0;
    var createDb = false;
	var sqlfiles = ""
  	if (nargs.Exists("createDb")) {
  		i++;
   		createDb = true;   
  	}
	if ( (createDb && (uargs.Length != 0))
	     ||(!createDb && (uargs.Length == 0)) ) {
    	usage();
   		WScript.Quit(1);   			
	}
  	if (fso.FileExists(dbname)) {
    	WScript.Echo(" - C    (" + dbname + ") ...");
    	dbname_bak = backupDataBaseName();
    	if (createDb)
    		fso.MoveFile(dbname, dbname_bak);
    	else
    		fso.CopyFile(dbname, dbname_bak);    	
    	WScript.Echo("     OK (  " + dbname_bak + ")");
  	}
  	if (createDb) {  	
  		var fold = fso.getFolder(scriptFolder);  	
  		var FilesEnumerator = new Enumerator(fold.Files);
	   	WScript.Echo(" - C  ");
    	while (!FilesEnumerator.atEnd()){
    		var fileName = FilesEnumerator.item().Name; 
	   		WScript.Echo("   - " + fileName);
       		scriptExecute(fileName);
			FilesEnumerator.moveNext();
    	} 
    }
    else {
	   	WScript.Echo(" -   ");
    	for (var i = 0; i < uargs.Length; i ++) {
    		var fileName = uargs.item(i); 
	   		WScript.Echo("   - " + fileName);
    		scriptExecute(fileName);
    	}
    }
	WScript.Echo("");	
} catch (e) {
	WScript.Echo("\n!!! " + e.description);
	WScript.Echo("\n   ...");
	WScript.StdIn.ReadLine();
}


function usage() {
  WScript.Echo(": " + WScript.ScriptName + " [/createDb]");
  WScript.Echo("               " + WScript.ScriptName + " file1.sql [file2.sql] ... [fileN.sql]");
}

function backupDataBaseName() {
   var d = new Date();
   var yy = d.getYear().toString().slice(-2);
   var mm = ("00" + (d.getMonth() + 1)).slice(-2);
   var dd = ("00" + d.getDate()).slice(-2);
   var hh = ("00" + d.getHours()).slice(-2);
   var nn = ("00" + d.getMinutes()).slice(-2);
   var ss = ("00" + d.getSeconds()).slice(-2);  
   var dbname_bak = dbname + "-" + yy + mm + dd + '-' + hh + nn + ss + ".BAK";
   return dbname_bak;
}

function scriptExecute(fileName) {
	var fileFullName = scriptFolder + fileName;
	if (!fso.FileExists(fileFullName))
    	throw new Error(1, "  ");	
	var resFile = fileName + ".res";
	try {fso.DeleteFile(resFile)} catch (e){};
	var cmdLine = "ibscript.exe " + fileFullName + " -db " + dbname + " -u SYSDBA -p masterkey" + " -o " + resFile;
	var sh = WScript.CreateObject("WScript.Shell");
	var res = sh.Run(cmdLine, 1, true);
    if (res != 0)
    	throw new Error(1, "  : " + quote + fileName + quote + "\n  " + quote + resFile + quote);
	try {fso.DeleteFile(resFile)} catch (e){};
}
